{+-----------------------------------------------------------------------------+
 | Created:     1998-12-16
 | Last change: 2000-01-23
 | Author:      Primoz Gabrijelcic
 | Description: One unit to bind them - common Register for all mwEdit
 |              components
 | Version:     0.22
 | Copyright (c) 1998 Primoz Gabrijelcic
 | No rights reserved.
 |
 | Thanks to: Brad Stowers
 |
 | Version history: see version.rtf
 |
 +----------------------------------------------------------------------------+}

unit mwEditReg;

{$I mwEdit.inc}

interface

procedure Register;

implementation

uses
  mwCustomEdit, mwKeyCmds, mwKeyCmdsEditor, mwEditPropertyReg,
  mwPasSyn, DcjCppSyn, DcjPerlSyn, mwGeneralSyn, cbHPSyn,
  DcjJavaSyn, cwCACSyn, wmSQLSyn, hkHTMLSyn, hkAWKSyn, siTclTksyn,
  lbVBSSyn, odPySyn, odPythonBehaviour, mkGalaxySyn,
  mwRTFExport, mwHTMLExport,
  DBmwEdit, dmBatSyn, dmDfmSyn, nhAsmSyn, mwCompletionProposal, mwDmlSyn,
  izIniSyn, dmMLSyn, psVisualBasicSyn, wbADSP21xxSyn, wmPHPSyn, wmMultiSyn,
  wmSybaseSyn, mwCacheSyn, mwCSSSyn, mwJScriptSyn, jsKixSyn, mwBaanSyn,
{$IFDEF MWE_COMPILER_3_UP}
  mwHighlighterManager,                                                         //gp 2000-01-20
{$ENDIF}
  mwFortranSyn, mwFoxproSyn, CIHC11Syn;

procedure Register;                                                             //gp 2000-01-20 - re-arranged
begin
  mwCustomEdit.Register;           //MWS_ComponentsPage
  DBmwEdit.Register;
  mwRTFExport.Register;
  mwHTMLExport.Register;
  mwCompletionProposal.Register;
  odPythonBehaviour.Register;
  mwEditPropertyReg.Register;
  wmMultiSyn.Register;
{$IFDEF MWE_COMPILER_3_UP}
  mwHighlighterManager.Register;
{$ENDIF}
  mwGeneralSyn.Register;           //MWS_HighlightersPage
  mwPasSyn.Register;               //classic
  DcjCppSyn.Register;
  DcjJavaSyn.Register;
  mwFortranSyn.Register;
  psVisualBasicSyn.Register;
  hkHTMLSyn.Register;              //internet
  mwCSSSyn.Register;
  wmPHPSyn.Register;
  lbVBSSyn.Register;
  mwJScriptSyn.Register;
  hkAWKSyn.Register;               //interpreted
  DcjPerlSyn.Register;
  siTclTksyn.Register;
  odPySyn.Register;
  dmBatSyn.Register;
  cwCACSyn.Register;               //database
  mwFoxproSyn.Register;
  wmSQLSyn.Register;
  wmSybaseSyn.Register;
  mwCacheSyn.Register;
  cbHPSyn.Register;                //assembler
  CIHC11Syn.Register;
  nhAsmSyn.Register;
  wbADSP21xxSyn.Register;
  mwDmlSyn.Register;               //data modeling
  dmMLSyn.Register;
  mkGalaxySyn.Register;            //data
  dmDfmSyn.Register;
  izIniSyn.Register;
  jsKixSyn.Register;               //weird
  mwBaanSyn.Register;
end; { Register }

end.

