{+-----------------------------------------------------------------------------+
 | Class:       TwmSybSQLSyn
 | Created:     not known
 | Last change: 2000-01-21
 | Author:      Willo van der Merwe [willo@wack.co.za]
 | Description: Sybase SQL syntax highliter
 | Version:     0.51
 | Copyright (c) 1999 Willo van der Merwe
 | All rights reserved.
 | Portions Copyright Martin Waldenburg.
 | Initially Created with mwSynGen by Martin Waldenburg.
 |
 | Version history: see version.rtf
 |
 +----------------------------------------------------------------------------+}

unit wmSybaseSyn;

{$I mwEdit.inc}

interface

uses
  SysUtils, Windows, Messages, Classes, Controls, Graphics, Registry,
  mwHighlighter;

Type
  TtkTokenKind = (
    tkComment,
    tkIdentifier,
    tkInvalidSymbol,
    tkKey,
    tkNull,
    tkNumber,
    tkSpace,
    tkString,
    tkSymbol,
    tkUnknown,
    tkVariable);

  TRangeState = (rsUnKnown, rsComment);

  TProcTableProc = procedure of Object;

  PIdentFuncTableFunc = ^TIdentFuncTableFunc;
  TIdentFuncTableFunc = function: TtkTokenKind of Object;

type
  TwmSybSQLSyn = class(TmwCustomHighLighter)
  private
    fRange: TRangeState;
    fLine: PChar;
    fLineNumber: Integer;
    fProcTable: array[#0..#255] of TProcTableProc;
    Run: LongInt;
//    fRoundCount: Integer;                                                     //mh 2000-01-21
    fStringLen: Integer;
    fToIdent: PChar;
    fTokenPos: Integer;
    FTokenID: TtkTokenKind;
    fIdentFuncTable: array[0..274] of TIdentFuncTableFunc;
    fCommentAttri: TmwHighLightAttributes;
    fIdentifierAttri: TmwHighLightAttributes;
    fInvalidSymbolAttri: TmwHighLightAttributes;
    fKeyAttri: TmwHighLightAttributes;
    fNumberAttri: TmwHighLightAttributes;
    fSpaceAttri: TmwHighLightAttributes;
    fStringAttri: TmwHighLightAttributes;
    fSymbolAttri: TmwHighLightAttributes;
    fVariableAttri: TmwHighLightAttributes;
    function KeyHash(ToHash: PChar): Integer;
    function KeyComp(const aKey: String): Boolean;
    function Func9:TtkTokenKind;
    function Func12:TtkTokenKind;
    function Func15:TtkTokenKind;
    function Func17:TtkTokenKind;
    function Func19:TtkTokenKind;
    function Func20:TtkTokenKind;
    function Func21:TtkTokenKind;
    function Func22:TtkTokenKind;
    function Func23:TtkTokenKind;
    function Func24:TtkTokenKind;
    function Func25:TtkTokenKind;
    function Func26:TtkTokenKind;
    function Func27:TtkTokenKind;
    function Func28:TtkTokenKind;
    function Func29:TtkTokenKind;
    function Func30:TtkTokenKind;
    function Func31:TtkTokenKind;
    function Func32:TtkTokenKind;
    function Func33:TtkTokenKind;
    function Func35:TtkTokenKind;
    function Func36:TtkTokenKind;
    function Func37:TtkTokenKind;
    function Func38:TtkTokenKind;
    function Func39:TtkTokenKind;
    function Func40:TtkTokenKind;
    function Func41:TtkTokenKind;
    function Func42:TtkTokenKind;
    function Func43:TtkTokenKind;
    function Func44:TtkTokenKind;
    function Func45:TtkTokenKind;
    function Func46:TtkTokenKind;
    function Func47:TtkTokenKind;
    function Func48:TtkTokenKind;
    function Func49:TtkTokenKind;
    function Func50:TtkTokenKind;
    function Func51:TtkTokenKind;
    function Func52:TtkTokenKind;
    function Func53:TtkTokenKind;
    function Func54:TtkTokenKind;
    function Func55:TtkTokenKind;
    function Func56:TtkTokenKind;
    function Func57:TtkTokenKind;
    function Func58:TtkTokenKind;
    function Func59:TtkTokenKind;
    function Func60:TtkTokenKind;
    function Func61:TtkTokenKind;
    function Func62:TtkTokenKind;
    function Func63:TtkTokenKind;
    function Func64:TtkTokenKind;
    function Func65:TtkTokenKind;
    function Func66:TtkTokenKind;
    function Func67:TtkTokenKind;
    function Func68:TtkTokenKind;
    function Func69:TtkTokenKind;
    function Func70:TtkTokenKind;
    function Func71:TtkTokenKind;
    function Func72:TtkTokenKind;
    function Func73:TtkTokenKind;
    function Func74:TtkTokenKind;
    function Func75:TtkTokenKind;
    function Func76:TtkTokenKind;
    function Func77:TtkTokenKind;
    function Func78:TtkTokenKind;
    function Func79:TtkTokenKind;
    function Func80:TtkTokenKind;
    function Func81:TtkTokenKind;
    function Func82:TtkTokenKind;
    function Func83:TtkTokenKind;
    function Func84:TtkTokenKind;
    function Func85:TtkTokenKind;
    function Func86:TtkTokenKind;
    function Func87:TtkTokenKind;
    function Func89:TtkTokenKind;
    function Func90:TtkTokenKind;
    function Func91:TtkTokenKind;
    function Func92:TtkTokenKind;
    function Func93:TtkTokenKind;
    function Func94:TtkTokenKind;
    function Func95:TtkTokenKind;
    function Func96:TtkTokenKind;
    function Func97:TtkTokenKind;
    function Func98:TtkTokenKind;
    function Func99:TtkTokenKind;
    function Func100:TtkTokenKind;
    function Func101:TtkTokenKind;
    function Func102:TtkTokenKind;
    function Func103:TtkTokenKind;
    function Func104:TtkTokenKind;
    function Func105:TtkTokenKind;
    function Func106:TtkTokenKind;
    function Func107:TtkTokenKind;
    function Func108:TtkTokenKind;
    function Func109:TtkTokenKind;
    function Func110:TtkTokenKind;
    function Func111:TtkTokenKind;
    function Func112:TtkTokenKind;
    function Func113:TtkTokenKind;
    function Func114:TtkTokenKind;
    function Func115:TtkTokenKind;
    function Func116:TtkTokenKind;
    function Func117:TtkTokenKind;
    function Func118:TtkTokenKind;
    function Func120:TtkTokenKind;
    function Func121:TtkTokenKind;
    function Func122:TtkTokenKind;
    function Func124:TtkTokenKind;
    function Func127:TtkTokenKind;
    function Func128:TtkTokenKind;
    function Func129:TtkTokenKind;
    function Func131:TtkTokenKind;
    function Func132:TtkTokenKind;
    function Func133:TtkTokenKind;
    function Func134:TtkTokenKind;
    function Func139:TtkTokenKind;
    function Func143:TtkTokenKind;
    function Func144:TtkTokenKind;
    function Func145:TtkTokenKind;
    function Func149:TtkTokenKind;
    function Func150:TtkTokenKind;
    function Func152:TtkTokenKind;
    function Func153:TtkTokenKind;
    function Func157:TtkTokenKind;
    function Func158:TtkTokenKind;
    function Func159:TtkTokenKind;
    function Func160:TtkTokenKind;
    function Func161:TtkTokenKind;
    function Func167:TtkTokenKind;
    function Func169:TtkTokenKind;
    function Func174:TtkTokenKind;
    function Func177:TtkTokenKind;
    function Func183:TtkTokenKind;
    function Func193:TtkTokenKind;
    function Func194:TtkTokenKind;
    function Func195:TtkTokenKind;
    function Func200:TtkTokenKind;
    function Func203:TtkTokenKind;
    function Func215:TtkTokenKind;
    function Func220:TtkTokenKind;
    function Func222:TtkTokenKind;
    function Func246:TtkTokenKind;
    function Func249:TtkTokenKind;
    function Func274:TtkTokenKind;
    procedure AndSymbolProc;
    procedure AsciiCharProc;
    procedure BraceCloseProc;
    procedure BraceOpenProc;
    procedure CRProc;
    procedure ColonProc;
    procedure CommaProc;
    procedure EqualProc;
    procedure GreaterProc;
    procedure IdentProc;
    procedure LFProc;
    procedure LowerProc;
    procedure MinusProc;
    procedure MultiplyProc;
    procedure NotSymbolProc;
    procedure NullProc;
    procedure NumberProc;
    procedure OrSymbolProc;
    procedure PlusProc;
    procedure PointProc;
    procedure QuestionProc;
    procedure RemainderSymbolProc;
    procedure RoundCloseProc;
    procedure RoundOpenProc;
    procedure SemiColonProc;
    procedure SlashProc;
    procedure SpaceProc;
    procedure SquareCloseProc;
    procedure SquareOpenProc;
    procedure StringProc;
    procedure TildeProc;
    procedure VariableProc;
    procedure XOrSymbolProc;
    procedure UnknownProc;
    function AltFunc: TtkTokenKind;
    procedure InitIdent;
    function IdentKind(MayBe: PChar): TtkTokenKind;
    procedure MakeMethodTables;
    procedure AnsiCProc;
  protected
    function GetIdentChars: TIdentChars; override;
  public
    class function GetCapability: THighlighterCapability; override;             //gp 2000-01-20
    class function GetLanguageName: string; override;                           //gp 2000-01-20
  public
    constructor Create(AOwner: TComponent); override;
    function GetDefaultAttribute(Index: integer): TmwHighLightAttributes;       //mh 2000-01-17
      override;
    function GetEOL: Boolean; override;
    function GetRange: Pointer; override;
    function GetTokenID: TtkTokenKind;
    procedure SetLine(NewValue: String; LineNumber: Integer); override;
    procedure ExportNext; override;
    procedure SetLineForExport(NewValue: String); override;
    function GetToken: String; override;
    function GetTokenAttribute: TmwHighLightAttributes; override;
    function GetTokenKind: integer; override;
    function GetTokenPos: Integer; override;
    procedure Next; override;
    procedure SetRange(Value: Pointer); override;
    procedure ReSetRange; override;
    property IdentChars;
  published
    property CommentAttri: TmwHighLightAttributes read fCommentAttri
      write fCommentAttri;
    property IdentifierAttri: TmwHighLightAttributes read fIdentifierAttri
      write fIdentifierAttri;
    property InvalidSymbolAttri: TmwHighLightAttributes read fInvalidSymbolAttri
      write fInvalidSymbolAttri;
    property KeyAttri: TmwHighLightAttributes read fKeyAttri write fKeyAttri;
    property NumberAttri: TmwHighLightAttributes read fNumberAttri
      write fNumberAttri;
    property SpaceAttri: TmwHighLightAttributes read fSpaceAttri
      write fSpaceAttri;
    property StringAttri: TmwHighLightAttributes read fStringAttri
      write fStringAttri;
    property SymbolAttri: TmwHighLightAttributes read fSymbolAttri
      write fSymbolAttri;
    property VariableAttri: TmwHighLightAttributes read fVariableAttri
      write fVariableAttri;
  end;

procedure Register;

implementation

uses
  mwLocalStr, mwExport;                                                         //riceball 2000-01-14

procedure Register;
begin
  RegisterComponents(MWS_HighlightersPage, [TwmSybSQLSyn]);
end;

var
  Identifiers: array[#0..#255] of ByteBool;
  mHashTable: array[#0..#255] of Integer;

procedure MakeIdentTable;
var
  I, J: Char;
begin
  for I := #0 to #255 do
  begin
    Case I of
      '_', '0'..'9', 'a'..'z', 'A'..'Z': Identifiers[I] := True;
    else Identifiers[I] := False;
    end;
    J := UpperCase(I)[1];
    Case I in ['_', 'A'..'Z', 'a'..'z'] of
      True: mHashTable[I] := Ord(J) - 64
    else mHashTable[I] := 0;
    end;
  end;
end;

procedure TwmSybSQLSyn.InitIdent;
var
  I: Integer;
  pF: PIdentFuncTableFunc;
begin
  pF := PIdentFuncTableFunc(@fIdentFuncTable);
  for I := Low(fIdentFuncTable) to High(fIdentFuncTable) do begin
    pF^ := AltFunc;
    Inc(pF);
  end;
  fIdentFuncTable[9] := Func9;
  fIdentFuncTable[12] := Func12;
  fIdentFuncTable[15] := Func15;
  fIdentFuncTable[17] := Func17;
  fIdentFuncTable[19] := Func19;
  fIdentFuncTable[20] := Func20;
  fIdentFuncTable[21] := Func21;
  fIdentFuncTable[22] := Func22;
  fIdentFuncTable[23] := Func23;
  fIdentFuncTable[24] := Func24;
  fIdentFuncTable[25] := Func25;
  fIdentFuncTable[26] := Func26;
  fIdentFuncTable[27] := Func27;
  fIdentFuncTable[28] := Func28;
  fIdentFuncTable[29] := Func29;
  fIdentFuncTable[30] := Func30;
  fIdentFuncTable[31] := Func31;
  fIdentFuncTable[32] := Func32;
  fIdentFuncTable[33] := Func33;
  fIdentFuncTable[35] := Func35;
  fIdentFuncTable[36] := Func36;
  fIdentFuncTable[37] := Func37;
  fIdentFuncTable[38] := Func38;
  fIdentFuncTable[39] := Func39;
  fIdentFuncTable[40] := Func40;
  fIdentFuncTable[41] := Func41;
  fIdentFuncTable[42] := Func42;
  fIdentFuncTable[43] := Func43;
  fIdentFuncTable[44] := Func44;
  fIdentFuncTable[45] := Func45;
  fIdentFuncTable[46] := Func46;
  fIdentFuncTable[47] := Func47;
  fIdentFuncTable[48] := Func48;
  fIdentFuncTable[49] := Func49;
  fIdentFuncTable[50] := Func50;
  fIdentFuncTable[51] := Func51;
  fIdentFuncTable[52] := Func52;
  fIdentFuncTable[53] := Func53;
  fIdentFuncTable[54] := Func54;
  fIdentFuncTable[55] := Func55;
  fIdentFuncTable[56] := Func56;
  fIdentFuncTable[57] := Func57;
  fIdentFuncTable[58] := Func58;
  fIdentFuncTable[59] := Func59;
  fIdentFuncTable[60] := Func60;
  fIdentFuncTable[61] := Func61;
  fIdentFuncTable[62] := Func62;
  fIdentFuncTable[63] := Func63;
  fIdentFuncTable[64] := Func64;
  fIdentFuncTable[65] := Func65;
  fIdentFuncTable[66] := Func66;
  fIdentFuncTable[67] := Func67;
  fIdentFuncTable[68] := Func68;
  fIdentFuncTable[69] := Func69;
  fIdentFuncTable[70] := Func70;
  fIdentFuncTable[71] := Func71;
  fIdentFuncTable[72] := Func72;
  fIdentFuncTable[73] := Func73;
  fIdentFuncTable[74] := Func74;
  fIdentFuncTable[75] := Func75;
  fIdentFuncTable[76] := Func76;
  fIdentFuncTable[77] := Func77;
  fIdentFuncTable[78] := Func78;
  fIdentFuncTable[79] := Func79;
  fIdentFuncTable[80] := Func80;
  fIdentFuncTable[81] := Func81;
  fIdentFuncTable[82] := Func82;
  fIdentFuncTable[83] := Func83;
  fIdentFuncTable[84] := Func84;
  fIdentFuncTable[85] := Func85;
  fIdentFuncTable[86] := Func86;
  fIdentFuncTable[87] := Func87;
  fIdentFuncTable[89] := Func89;
  fIdentFuncTable[90] := Func90;
  fIdentFuncTable[91] := Func91;
  fIdentFuncTable[92] := Func92;
  fIdentFuncTable[93] := Func93;
  fIdentFuncTable[94] := Func94;
  fIdentFuncTable[95] := Func95;
  fIdentFuncTable[96] := Func96;
  fIdentFuncTable[97] := Func97;
  fIdentFuncTable[98] := Func98;
  fIdentFuncTable[99] := Func99;
  fIdentFuncTable[100] := Func100;
  fIdentFuncTable[101] := Func101;
  fIdentFuncTable[102] := Func102;
  fIdentFuncTable[103] := Func103;
  fIdentFuncTable[104] := Func104;
  fIdentFuncTable[105] := Func105;
  fIdentFuncTable[106] := Func106;
  fIdentFuncTable[107] := Func107;
  fIdentFuncTable[108] := Func108;
  fIdentFuncTable[109] := Func109;
  fIdentFuncTable[110] := Func110;
  fIdentFuncTable[111] := Func111;
  fIdentFuncTable[112] := Func112;
  fIdentFuncTable[113] := Func113;
  fIdentFuncTable[114] := Func114;
  fIdentFuncTable[115] := Func115;
  fIdentFuncTable[116] := Func116;
  fIdentFuncTable[117] := Func117;
  fIdentFuncTable[118] := Func118;
  fIdentFuncTable[120] := Func120;
  fIdentFuncTable[121] := Func121;
  fIdentFuncTable[122] := Func122;
  fIdentFuncTable[124] := Func124;
  fIdentFuncTable[127] := Func127;
  fIdentFuncTable[128] := Func128;
  fIdentFuncTable[129] := Func129;
  fIdentFuncTable[131] := Func131;
  fIdentFuncTable[132] := Func132;
  fIdentFuncTable[133] := Func133;
  fIdentFuncTable[134] := Func134;
  fIdentFuncTable[139] := Func139;
  fIdentFuncTable[143] := Func143;
  fIdentFuncTable[144] := Func144;
  fIdentFuncTable[145] := Func145;
  fIdentFuncTable[149] := Func149;
  fIdentFuncTable[150] := Func150;
  fIdentFuncTable[152] := Func152;
  fIdentFuncTable[153] := Func153;
  fIdentFuncTable[157] := Func157;
  fIdentFuncTable[158] := Func158;
  fIdentFuncTable[159] := Func159;
  fIdentFuncTable[160] := Func160;
  fIdentFuncTable[161] := Func161;
  fIdentFuncTable[167] := Func167;
  fIdentFuncTable[169] := Func169;
  fIdentFuncTable[174] := Func174;
  fIdentFuncTable[177] := Func177;
  fIdentFuncTable[183] := Func183;
  fIdentFuncTable[193] := Func193;
  fIdentFuncTable[194] := Func194;
  fIdentFuncTable[195] := Func195;
  fIdentFuncTable[200] := Func200;
  fIdentFuncTable[203] := Func203;
  fIdentFuncTable[215] := Func215;
  fIdentFuncTable[220] := Func220;
  fIdentFuncTable[222] := Func222;
  fIdentFuncTable[246] := Func246;
  fIdentFuncTable[249] := Func249;
  fIdentFuncTable[274] := Func274;
end;

function TwmSybSQLSyn.KeyHash(ToHash: PChar): Integer;
begin
  Result := 0;
  while ToHash^ in ['_', '0'..'9', 'a'..'z', 'A'..'Z'] do
  begin
    inc(Result, mHashTable[ToHash^]);
    inc(ToHash);
  end;
  fStringLen := ToHash - fToIdent;
end;

function TwmSybSQLSyn.KeyComp(const aKey: String): Boolean;
var
  I: Integer;
  Temp: PChar;
begin
  Temp := fToIdent;
  if Length(aKey) = fStringLen then
  begin
    Result := True;
    for i := 1 to fStringLen do
    begin
      if mHashTable[Temp^] <> mHashTable[aKey[i]] then
      begin
        Result := False;
        break;
      end;
      inc(Temp);
    end;
  end else Result := False;
end;

function TwmSybSQLSyn.Func9: TtkTokenKind;
begin
  if KeyComp('add') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func12: TtkTokenKind;
begin
  if KeyComp('dbcc') then Result := tkKey else
    if KeyComp('dec') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func15: TtkTokenKind;
begin
  if KeyComp('if') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func17: TtkTokenKind;
begin
  if KeyComp('each') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func19: TtkTokenKind;
begin
  if KeyComp('en') then Result := tkKey else
    if KeyComp('and') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func20: TtkTokenKind;
begin
  if KeyComp('as') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func21: TtkTokenKind;
begin
  if KeyComp('pad') then Result := tkKey else
    if KeyComp('of') then Result := tkKey else
      if KeyComp('at') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func22: TtkTokenKind;
begin
  if KeyComp('go') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func23: TtkTokenKind;
begin
  if KeyComp('asc') then Result := tkKey else
    if KeyComp('in') then Result := tkKey else
      if KeyComp('end') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func24: TtkTokenKind;
begin
  if KeyComp('are') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func25: TtkTokenKind;
begin
  if KeyComp('all') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func26: TtkTokenKind;
begin
  if KeyComp('data') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func27: TtkTokenKind;
begin
  if KeyComp('off') then Result := tkKey else
    if KeyComp('by') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func28: TtkTokenKind;
begin
  if KeyComp('call') then Result := tkKey else
    if KeyComp('oid') then Result := tkKey else
      if KeyComp('case') then Result := tkKey else
        if KeyComp('read') then Result := tkKey else
          if KeyComp('case') then Result := tkKey else
            if KeyComp('is') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func29: TtkTokenKind;
begin
  if KeyComp('ref') then Result := tkKey else
    if KeyComp('on') then Result := tkKey else
      if KeyComp('jar') then Result := tkKey else
        if KeyComp('no') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func30: TtkTokenKind;
begin
  if KeyComp('day') then Result := tkKey else
    if KeyComp('check') then Result := tkKey else
      if KeyComp('avg') then Result := tkKey else
        if KeyComp('date') then Result := tkKey else
          if KeyComp('char') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func31: TtkTokenKind;
begin
  if KeyComp('old') then Result := tkKey else
    if KeyComp('desc') then Result := tkKey else
      if KeyComp('bit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func32: TtkTokenKind;
begin
  if KeyComp('dis') then Result := tkKey else
    if KeyComp('get') then Result := tkKey else
      if KeyComp('load') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func33: TtkTokenKind;
begin
  if KeyComp('or') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func35: TtkTokenKind;
begin
  if KeyComp('to') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func36: TtkTokenKind;
begin
  if KeyComp('cascade') then Result := tkKey else
    if KeyComp('real') then Result := tkKey else
      if KeyComp('min') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func37: TtkTokenKind;
begin
  if KeyComp('begin') then Result := tkKey else
    if KeyComp('exec') then Result := tkKey else
      if KeyComp('exec') then Result := tkKey else
        if KeyComp('once') then Result := tkKey else
          if KeyComp('like') then Result := tkKey else
            if KeyComp('break') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func38: TtkTokenKind;
begin
  if KeyComp('max') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func39: TtkTokenKind;
begin
  if KeyComp('for') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func40: TtkTokenKind;
begin
  if KeyComp('cascaded') then Result := tkKey else
    if KeyComp('table') then Result := tkKey else
      if KeyComp('any') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func41: TtkTokenKind;
begin
  if KeyComp('key') then Result := tkKey else
    if KeyComp('lock') then Result := tkKey else
      if KeyComp('else') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func42: TtkTokenKind;
begin
  if KeyComp('fetch') then Result := tkKey else
    if KeyComp('alias') then Result := tkKey else
      if KeyComp('new') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func43: TtkTokenKind;
begin
  if KeyComp('int') then Result := tkKey else
    if KeyComp('left') then Result := tkKey else
      if KeyComp('false') then Result := tkKey else
        if KeyComp('local') then Result := tkKey else
          if KeyComp('plan') then Result := tkKey else
            if KeyComp('cast') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func44: TtkTokenKind;
begin
  if KeyComp('kill') then Result := tkKey else
    if KeyComp('set') then Result := tkKey else
      if KeyComp('nchar') then Result := tkKey else
        if KeyComp('space') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func45: TtkTokenKind;
begin
  if KeyComp('leave') then Result := tkKey else
    if KeyComp('match') then Result := tkKey else
      if KeyComp('both') then Result := tkKey else
        if KeyComp('use') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func46: TtkTokenKind;
begin
  if KeyComp('bulk') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func47: TtkTokenKind;
begin
  if KeyComp('time') then Result := tkKey else
    if KeyComp('decimal') then Result := tkKey else
      if KeyComp('then') then Result := tkKey else
        if KeyComp('save') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func48: TtkTokenKind;
begin
  if KeyComp('join') then Result := tkKey else
    if KeyComp('declare') then Result := tkKey else
      if KeyComp('none') then Result := tkKey else
        if KeyComp('join') then Result := tkKey else
          if KeyComp('cycle') then Result := tkKey else
            if KeyComp('sql') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func49: TtkTokenKind;
begin
  if KeyComp('not') then Result := tkKey else
    if KeyComp('schema') then Result := tkKey else
      if KeyComp('global') then Result := tkKey else
        if KeyComp('year') then Result := tkKey else
          if KeyComp('escape') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func50: TtkTokenKind;
begin
  if KeyComp('after') then Result := tkKey else
    if KeyComp('when') then Result := tkKey else
      if KeyComp('when') then Result := tkKey else
        if KeyComp('open') then Result := tkKey else
          if KeyComp('role') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func51: TtkTokenKind;
begin
  if KeyComp('before') then Result := tkKey else
    if KeyComp('delete') then Result := tkKey else
      if KeyComp('full') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func52: TtkTokenKind;
begin
  if KeyComp('leading') then Result := tkKey else
    if KeyComp('names') then Result := tkKey else
      if KeyComp('from') then Result := tkKey else
        if KeyComp('last') then Result := tkKey else
          if KeyComp('proc') then Result := tkKey else
            if KeyComp('perm') then Result := tkKey else
              if KeyComp('some') then Result := tkKey else
                if KeyComp('create') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func53: TtkTokenKind;
begin
  if KeyComp('tran') then Result := tkKey else
    if KeyComp('sum') then Result := tkKey else
      if KeyComp('wait') then Result := tkKey else
        if KeyComp('usage') then Result := tkKey else
          if KeyComp('database') then Result := tkKey else
            if KeyComp('drop') then Result := tkKey else
              if KeyComp('depth') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func54: TtkTokenKind;
begin
  if KeyComp('close') then Result := tkKey else
    if KeyComp('dump') then Result := tkKey else
      if KeyComp('float') then Result := tkKey else
        if KeyComp('temp') then Result := tkKey else
          if KeyComp('search') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func55: TtkTokenKind;
begin
  if KeyComp('less') then Result := tkKey else
    if KeyComp('object') then Result := tkKey else
      if KeyComp('shared') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func56: TtkTokenKind;
begin
  if KeyComp('level') then Result := tkKey else
    if KeyComp('rule') then Result := tkKey else
      if KeyComp('index') then Result := tkKey else
        if KeyComp('alter') then Result := tkKey else
          if KeyComp('elseif') then Result := tkKey else
            if KeyComp('there') then Result := tkKey else
              if KeyComp('row') then Result := tkKey else
                if KeyComp('domain') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func57: TtkTokenKind;
begin
  if KeyComp('goto') then Result := tkKey else
    if KeyComp('while') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func58: TtkTokenKind;
begin
  if KeyComp('loop') then Result := tkKey else
    if KeyComp('breadth') then Result := tkKey else
      if KeyComp('into') then Result := tkKey else
        if KeyComp('exit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func59: TtkTokenKind;
begin
  if KeyComp('double') then Result := tkKey else
    if KeyComp('null') then Result := tkKey else
      if KeyComp('catalog') then Result := tkKey else
        if KeyComp('view') then Result := tkKey else
          if KeyComp('where') then Result := tkKey else
            if KeyComp('size') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func60: TtkTokenKind;
begin
  if KeyComp('order') then Result := tkKey else
    if KeyComp('found') then Result := tkKey else
      if KeyComp('with') then Result := tkKey else
        if KeyComp('trim') then Result := tkKey else
          if KeyComp('grant') then Result := tkKey else
            if KeyComp('second') then Result := tkKey else
              if KeyComp('inner') then Result := tkKey else
                if KeyComp('zone') then Result := tkKey else
                  if KeyComp('replace') then Result := tkKey else
                    if KeyComp('over') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func61: TtkTokenKind;
begin
  if KeyComp('having') then Result := tkKey else
    if KeyComp('value') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func62: TtkTokenKind;
begin
  if KeyComp('under') then Result := tkKey else
    if KeyComp('right') then Result := tkKey else
      if KeyComp('hour') then Result := tkKey else
        if KeyComp('async') then Result := tkKey else
          if KeyComp('action') then Result := tkKey else
            if KeyComp('general') then Result := tkKey else
              if KeyComp('signal') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func63: TtkTokenKind;
begin
  if KeyComp('coalesce') then Result := tkKey else
    if KeyComp('next') then Result := tkKey else
      if KeyComp('public') then Result := tkKey else
        if KeyComp('reorg') then Result := tkKey else
          if KeyComp('coalesce') then Result := tkKey else
            if KeyComp('user') then Result := tkKey else
              if KeyComp('limit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func64: TtkTokenKind;
begin
  if KeyComp('select') then Result := tkKey else
    if KeyComp('boolean') then Result := tkKey else
      if KeyComp('test') then Result := tkKey else
        if KeyComp('true') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func65: TtkTokenKind;
begin
  if KeyComp('describe') then Result := tkKey else
    if KeyComp('deferred') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func66: TtkTokenKind;
begin
  if KeyComp('type') then Result := tkKey else
    if KeyComp('only') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func67: TtkTokenKind;
begin
  if KeyComp('work') then Result := tkKey else
    if KeyComp('update') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func68: TtkTokenKind;
begin
  if KeyComp('collate') then Result := tkKey else
    if KeyComp('ignore') then Result := tkKey else
      if KeyComp('language') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func69: TtkTokenKind;
begin
  if KeyComp('lineno') then Result := tkKey else
    if KeyComp('online') then Result := tkKey else
      if KeyComp('allocate') then Result := tkKey else
        if KeyComp('default') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func70: TtkTokenKind;
begin
  if KeyComp('module') then Result := tkKey else
    if KeyComp('variable') then Result := tkKey else
      if KeyComp('using') then Result := tkKey else
        if KeyComp('month') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func71: TtkTokenKind;
begin
  if KeyComp('varchar') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func72: TtkTokenKind;
begin
  if KeyComp('modify') then Result := tkKey else
    if KeyComp('modify') then Result := tkKey else
      if KeyComp('first') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func73: TtkTokenKind;
begin
  if KeyComp('commit') then Result := tkKey else
    if KeyComp('count') then Result := tkKey else
      if KeyComp('union') then Result := tkKey else
        if KeyComp('except') then Result := tkKey else
          if KeyComp('lower') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func74: TtkTokenKind;
begin
  if KeyComp('between') then Result := tkKey else
    if KeyComp('cross') then Result := tkKey else
      if KeyComp('nullif') then Result := tkKey else
        if KeyComp('rollback') then Result := tkKey else
          if KeyComp('pendant') then Result := tkKey else
            if KeyComp('nullif') then Result := tkKey else
              if KeyComp('foreign') then Result := tkKey else
                if KeyComp('connect') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func75: TtkTokenKind;
begin
  if KeyComp('rows') then Result := tkKey else
    if KeyComp('sqlcode') then Result := tkKey else
      if KeyComp('equals') then Result := tkKey else
        if KeyComp('write') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func76: TtkTokenKind;
begin
  if KeyComp('prior') then Result := tkKey else
    if KeyComp('deferrable') then Result := tkKey else
      if KeyComp('endtran') then Result := tkKey else
        if KeyComp('upper') then Result := tkKey else
          if KeyComp('revoke') then Result := tkKey else
            if KeyComp('dummy') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func77: TtkTokenKind;
begin
  if KeyComp('character') then Result := tkKey else
    if KeyComp('partial') then Result := tkKey else
      if KeyComp('group') then Result := tkKey else
        if KeyComp('print') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func78: TtkTokenKind;
begin
  if KeyComp('deallocate') then Result := tkKey else
    if KeyComp('remove') then Result := tkKey else
      if KeyComp('confirm') then Result := tkKey else
        if KeyComp('column') then Result := tkKey else
          if KeyComp('visible') then Result := tkKey else
            if KeyComp('integer') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func79: TtkTokenKind;
begin
  if KeyComp('outer') then Result := tkKey else
    if KeyComp('quiesce') then Result := tkKey else
      if KeyComp('immediate') then Result := tkKey else
        if KeyComp('prepare') then Result := tkKey else
          if KeyComp('scroll') then Result := tkKey else
            if KeyComp('reference') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func80: TtkTokenKind;
begin
  if KeyComp('holdlock') then Result := tkKey else
    if KeyComp('values') then Result := tkKey else
      if KeyComp('input') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func81: TtkTokenKind;
begin
  if KeyComp('similar') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func82: TtkTokenKind;
begin
  if KeyComp('minute') then Result := tkKey else
    if KeyComp('browse') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func83: TtkTokenKind;
begin
  if KeyComp('execute') then Result := tkKey else
    if KeyComp('numeric') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func84: TtkTokenKind;
begin
  if KeyComp('trigger') then Result := tkKey else
    if KeyComp('readpast') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func85: TtkTokenKind;
begin
  if KeyComp('insert') then Result := tkKey else
    if KeyComp('resignal') then Result := tkKey else
      if KeyComp('section') then Result := tkKey else
        if KeyComp('others') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func86: TtkTokenKind;
begin
  if KeyComp('national') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func87: TtkTokenKind;
begin
  if KeyComp('unique') then Result := tkKey else
    if KeyComp('errlvl') then Result := tkKey else
      if KeyComp('install') then Result := tkKey else
        if KeyComp('natural') then Result := tkKey else
          if KeyComp('stripe') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func89: TtkTokenKind;
begin
  if KeyComp('option') then Result := tkKey else
    if KeyComp('sequence') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func90: TtkTokenKind;
begin
  if KeyComp('trailing') then Result := tkKey else
    if KeyComp('offsets') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func91: TtkTokenKind;
begin
  if KeyComp('extract') then Result := tkKey else
    if KeyComp('private') then Result := tkKey else
      if KeyComp('mirror') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func92: TtkTokenKind;
begin
  if KeyComp('waitfor') then Result := tkKey else
    if KeyComp('relative') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func93: TtkTokenKind;
begin
  if KeyComp('indicator') then Result := tkKey else
    if KeyComp('compute') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func94: TtkTokenKind;
begin
  if KeyComp('cursor') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func95: TtkTokenKind;
begin
  if KeyComp('tsequal') then Result := tkKey else
    if KeyComp('absolute') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func96: TtkTokenKind;
begin
  if KeyComp('return') then Result := tkKey else
    if KeyComp('exists') then Result := tkKey else
      if KeyComp('varying') then Result := tkKey else
        if KeyComp('return') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func97: TtkTokenKind;
begin
  if KeyComp('readtext') then Result := tkKey else
    if KeyComp('convert') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func98: TtkTokenKind;
begin
  if KeyComp('distinct') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func99: TtkTokenKind;
begin
  if KeyComp('preorder') then Result := tkKey else
    if KeyComp('external') then Result := tkKey else
      if KeyComp('current') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func100: TtkTokenKind;
begin
  if KeyComp('smallint') then Result := tkKey else
    if KeyComp('errordata') then Result := tkKey else
      if KeyComp('whenever') then Result := tkKey else
        if KeyComp('primary') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func101: TtkTokenKind;
begin
  if KeyComp('continue') then Result := tkKey else
    if KeyComp('collation') then Result := tkKey else
      if KeyComp('interval') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func102: TtkTokenKind;
begin
  if KeyComp('truncate') then Result := tkKey else
    if KeyComp('routine') then Result := tkKey else
      if KeyComp('fillfactor') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func103: TtkTokenKind;
begin
  if KeyComp('virtual') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func104: TtkTokenKind;
begin
  if KeyComp('checkpoint') then Result := tkKey else
    if KeyComp('referencing') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func105: TtkTokenKind;
begin
  if KeyComp('procedure') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func106: TtkTokenKind;
begin
  if KeyComp('disconnect') then Result := tkKey else
    if KeyComp('permanent') then Result := tkKey else
      if KeyComp('identity') then Result := tkKey else
        if KeyComp('protected') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func107: TtkTokenKind;
begin
  if KeyComp('setuser') then Result := tkKey else
    if KeyComp('clustered') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func108: TtkTokenKind;
begin
  if KeyComp('preserve') then Result := tkKey else
    if KeyComp('overlaps') then Result := tkKey else
      if KeyComp('precision') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func109: TtkTokenKind;
begin
  if KeyComp('noholdlock') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func110: TtkTokenKind;
begin
  if KeyComp('translate') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func111: TtkTokenKind;
begin
  if KeyComp('initially') then Result := tkKey else
    if KeyComp('exception') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func112: TtkTokenKind;
begin
  if KeyComp('unknown') then Result := tkKey else
    if KeyComp('connection') then Result := tkKey else
      if KeyComp('restrict') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func113: TtkTokenKind;
begin
  if KeyComp('intersect') then Result := tkKey else
    if KeyComp('output') then Result := tkKey else
      if KeyComp('sqlstate') then Result := tkKey else
        if KeyComp('operation') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func114: TtkTokenKind;
begin
  if KeyComp('isolation') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func115: TtkTokenKind;
begin
  if KeyComp('returns') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func116: TtkTokenKind;
begin
  if KeyComp('parameters') then Result := tkKey else
    if KeyComp('timestamp') then Result := tkKey else
      if KeyComp('without') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func117: TtkTokenKind;
begin
  if KeyComp('position') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func118: TtkTokenKind;
begin
  if KeyComp('dictionary') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func120: TtkTokenKind;
begin
  if KeyComp('assertion') then Result := tkKey else
    if KeyComp('recursive') then Result := tkKey else
      if KeyComp('diagnostics') then Result := tkKey else
        if KeyComp('exclusive') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func121: TtkTokenKind;
begin
  if KeyComp('raiserror') then Result := tkKey else
    if KeyComp('savepoint') then Result := tkKey else
      if KeyComp('reconfigure') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func122: TtkTokenKind;
begin
  if KeyComp('sensitive') then Result := tkKey else
    if KeyComp('privileges') then Result := tkKey else
      if KeyComp('replication') then Result := tkKey else
        if KeyComp('sqlerror') then Result := tkKey else
          if KeyComp('completion') then Result := tkKey else
            if KeyComp('partition') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func124: TtkTokenKind;
begin
  if KeyComp('shutdown') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func127: TtkTokenKind;
begin
  if KeyComp('descriptor') then Result := tkKey else
    if KeyComp('char_length') then Result := tkKey else
      if KeyComp('operators') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func128: TtkTokenKind;
begin
  if KeyComp('textsize') then Result := tkKey else
    if KeyComp('bit_length') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func129: TtkTokenKind;
begin
  if KeyComp('substring') then Result := tkKey else
    if KeyComp('rowcount') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func131: TtkTokenKind;
begin
  if KeyComp('temporary') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func132: TtkTokenKind;
begin
  if KeyComp('errorexit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func133: TtkTokenKind;
begin
  if KeyComp('constraint') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func134: TtkTokenKind;
begin
  if KeyComp('transaction') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func139: TtkTokenKind;
begin
  if KeyComp('statistics') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func143: TtkTokenKind;
begin
  if KeyComp('translation') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func144: TtkTokenKind;
begin
  if KeyComp('writetext') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func145: TtkTokenKind;
begin
  if KeyComp('structure') then Result := tkKey else
    if KeyComp('reservepagegap') then Result := tkKey else
      if KeyComp('insensitive') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func149: TtkTokenKind;
begin
  if KeyComp('mirrorexit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func150: TtkTokenKind;
begin
  if KeyComp('nonclustered') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func152: TtkTokenKind;
begin
  if KeyComp('constraints') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func153: TtkTokenKind;
begin
  if KeyComp('controlrow') then Result := tkKey else
    if KeyComp('processexit') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func157: TtkTokenKind;
begin
  if KeyComp('corresponding') then Result := tkKey else
    if KeyComp('unpartition') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func158: TtkTokenKind;
begin
  if KeyComp('char_convert') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func159: TtkTokenKind;
begin
  if KeyComp('sqlexception') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func160: TtkTokenKind;
begin
  if KeyComp('octet_length') then Result := tkKey else
    if KeyComp('current_date') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func161: TtkTokenKind;
begin
  if KeyComp('identity_gap') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func167: TtkTokenKind;
begin
  if KeyComp('syb_restree') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func169: TtkTokenKind;
begin
  if KeyComp('proxy_table') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func174: TtkTokenKind;
begin
  if KeyComp('character_length') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func177: TtkTokenKind;
begin
  if KeyComp('authorization') then Result := tkKey else
    if KeyComp('current_time') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func183: TtkTokenKind;
begin
  if KeyComp('syb_identity') then Result := tkKey else
    if KeyComp('user_option') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func193: TtkTokenKind;
begin
  if KeyComp('current_user') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func194: TtkTokenKind;
begin
  if KeyComp('session_user') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func195: TtkTokenKind;
begin
  if KeyComp('system_user') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func200: TtkTokenKind;
begin
  if KeyComp('timezone_hour') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func203: TtkTokenKind;
begin
  if KeyComp('arith_overflow') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func215: TtkTokenKind;
begin
  if KeyComp('identity_start') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func220: TtkTokenKind;
begin
  if KeyComp('timezone_minute') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func222: TtkTokenKind;
begin
  if KeyComp('identity_insert') then Result := tkKey else
    if KeyComp('exp_row_size') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func246: TtkTokenKind;
begin
  if KeyComp('current_timestamp') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func249: TtkTokenKind;
begin
  if KeyComp('numeric_truncation') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.Func274: TtkTokenKind;
begin
  if KeyComp('max_rows_per_page') then Result := tkKey else Result := tkIdentifier;
end;

function TwmSybSQLSyn.AltFunc: TtkTokenKind;
begin
  Result := tkIdentifier;
end;

function TwmSybSQLSyn.IdentKind(MayBe: PChar): TtkTokenKind;
var
  HashKey: Integer;
begin
  fToIdent := MayBe;
  HashKey := KeyHash(MayBe);
  if HashKey < 275 then Result := fIdentFuncTable[HashKey] else Result := tkIdentifier;
end;

procedure TwmSybSQLSyn.MakeMethodTables;
var
  I: Char;
begin
  for I := #0 to #255 do
    case I of
      '&': fProcTable[I] := AndSymbolProc;
      #39: fProcTable[I] := AsciiCharProc;
      '}': fProcTable[I] := BraceCloseProc;
      '{': fProcTable[I] := BraceOpenProc;
      #13: fProcTable[I] := CRProc;
      ':': fProcTable[I] := ColonProc;
      ',': fProcTable[I] := CommaProc;
      '=': fProcTable[I] := EqualProc;
      '>': fProcTable[I] := GreaterProc;
      'A'..'Z', 'a'..'z', '_': fProcTable[I] := IdentProc;
      #10: fProcTable[I] := LFProc;
      '<': fProcTable[I] := LowerProc;
      '-': fProcTable[I] := MinusProc;
      '*': fProcTable[I] := MultiplyProc;
      '!': fProcTable[I] := NotSymbolProc;
      #0: fProcTable[I] := NullProc;
      '0'..'9': fProcTable[I] := NumberProc;
      '|': fProcTable[I] := OrSymbolProc;
      '+': fProcTable[I] := PlusProc;
      '.': fProcTable[I] := PointProc;
      '?': fProcTable[I] := QuestionProc;
      '%': fProcTable[I] := RemainderSymbolProc;
      ')': fProcTable[I] := RoundCloseProc;
      '(': fProcTable[I] := RoundOpenProc;
      ';': fProcTable[I] := SemiColonProc;
      '/': fProcTable[I] := SlashProc;
      #1..#9, #11, #12, #14..#32: fProcTable[I] := SpaceProc;
      ']': fProcTable[I] := SquareCloseProc;
      '[': fProcTable[I] := SquareOpenProc;
      #34: fProcTable[I] := StringProc;
      '~': fProcTable[I] := TildeProc;
      '@': fProcTable[I] := VariableProc;
      '^': fProcTable[I] := XOrSymbolProc;
      else fProcTable[I] := UnknownProc;
    end;
end;

constructor TwmSybSQLSyn.Create(AOwner: TComponent);
begin
{begin}                                                                         //mh 2000-01-14
  inherited Create(AOwner);
  fCommentAttri := TmwHighLightAttributes.Create(MWS_AttrComment);
  fCommentAttri.Style := [fsItalic];
  AddAttribute(fCommentAttri);
  fIdentifierAttri := TmwHighLightAttributes.Create(MWS_AttrIdentifier);
  AddAttribute(fIdentifierAttri);
  fInvalidSymbolAttri := TmwHighLightAttributes.Create(MWS_AttrInvalidSymbol);
  AddAttribute(fInvalidSymbolAttri);
  fKeyAttri := TmwHighLightAttributes.Create(MWS_AttrReservedWord);
  fKeyAttri.Style := [fsBold];
  AddAttribute(fKeyAttri);
  fNumberAttri := TmwHighLightAttributes.Create(MWS_AttrNumber);
  AddAttribute(fNumberAttri);
  fSpaceAttri := TmwHighLightAttributes.Create(MWS_AttrSpace);
  AddAttribute(fSpaceAttri);
  fStringAttri := TmwHighLightAttributes.Create(MWS_AttrString);
  AddAttribute(fStringAttri);
  fSymbolAttri := TmwHighLightAttributes.Create(MWS_AttrSymbol);
  AddAttribute(fSymbolAttri);
  fVariableAttri := TmwHighLightAttributes.Create(MWS_AttrVariable);
  AddAttribute(fVariableAttri);
{end}                                                                           //mh 2000-01-14
  SetAttributesOnChange(DefHighlightChange);
  InitIdent;
  MakeMethodTables;
  fDefaultFilter := MWS_FilterSQL;
  fRange := rsUnknown;
end;

procedure TwmSybSQLSyn.SetLine(NewValue: String; LineNumber: Integer);
begin
  fLine := PChar(NewValue);
  Run := 0;
  fLineNumber := LineNumber;
  Next;
end;

procedure TwmSybSQLSyn.AndSymbolProc;
begin
  case FLine[Run + 1] of
    '=':                               {and assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '&':                               {conditional and}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {and}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.AsciiCharProc;
begin
  fTokenID := tkString;
  repeat
    case FLine[Run] of
      #0, #10, #13: break;
    end;
    inc(Run);
  until FLine[Run] = #39;
  if FLine[Run] <> #0 then inc(Run);
end;

procedure TwmSybSQLSyn.BraceCloseProc;
begin
  inc(Run);
  fTokenId := tkSymbol;
end;

procedure TwmSybSQLSyn.BraceOpenProc;
begin
  inc(Run);
  fTokenId := tkSymbol;
end;

procedure TwmSybSQLSyn.CRProc;
begin
  fTokenID := tkSpace;
  Case FLine[Run + 1] of
    #10: inc(Run, 2);
  else inc(Run);
  end;
end;

procedure TwmSybSQLSyn.ColonProc;
begin
  inc(Run);                            {colon - conditional}
  fTokenID := tkSymbol;
end;

procedure TwmSybSQLSyn.CommaProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TwmSybSQLSyn.EqualProc;
begin
  case FLine[Run + 1] of
    '=':                               {logical equal}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '>':                               {Hash operator}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {assign}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.GreaterProc;
begin
  Case FLine[Run + 1] of
    '=':                               {greater than or equal to}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '>':
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {greater than}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.IdentProc;
begin
  fTokenID := IdentKind((fLine + Run));
  inc(Run, fStringLen);
  while Identifiers[fLine[Run]] do inc(Run);
end;

procedure TwmSybSQLSyn.LFProc;
begin
  fTokenID := tkSpace;
  inc(Run);
end;

procedure TwmSybSQLSyn.LowerProc;
begin
  case FLine[Run + 1] of
    '=':                               {less than or equal to}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '<':
      begin
        if FLine[Run + 2] = '=' then   {shift left assign}
        begin
          inc(Run, 3)
        end
        else                           {shift left}
        begin
          inc(Run, 2);
        end;
        fTokenID := tkSymbol;
      end;
  else                                 {less than}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.MinusProc;
begin
  case FLine[Run + 1] of
    '-':                               {comment}
      begin
        repeat
          inc(Run);
        until FLine[Run] in [#0, #10, #13];
        fTokenID := tkComment;
      end;
  else                                 {subtract}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.MultiplyProc;
begin
  case FLine[Run + 1] of
    '=':                               {multiply assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {multiply}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.NotSymbolProc;
begin
  case FLine[Run + 1] of
    '=':                               {not equal}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {logical complement}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.NullProc;
begin
  fTokenID := tkNull;
end;

procedure TwmSybSQLSyn.NumberProc;
begin
  inc(Run);
  fTokenID := tkNumber;
  while FLine[Run] in
      ['0'..'9', '.', '-'] do
  begin
    case FLine[Run] of
      '.':
        if FLine[Run + 1] = '.' then break;
    end;
    inc(Run);
  end;
end;

procedure TwmSybSQLSyn.OrSymbolProc;
begin
  case FLine[Run + 1] of
    '=':                               {inclusive or assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '|':                               {conditional or}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {inclusive or}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.PlusProc;
begin
  case FLine[Run + 1] of
    '=':                               {add assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '+':                               {increment}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {add}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.PointProc;
begin
  inc(Run);                            {point}
  fTokenID := tkSymbol;
end;

procedure TwmSybSQLSyn.QuestionProc;
begin
  fTokenID := tkSymbol;                {question mark - conditional}
  inc(Run);
end;

procedure TwmSybSQLSyn.RemainderSymbolProc;
begin
  case FLine[Run + 1] of
    '=':                               {remainder assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {remainder}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.RoundCloseProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
//  dec(FRoundCount);                                                           //mh 2000-01-21
end;

procedure TwmSybSQLSyn.RoundOpenProc;
begin
  inc(Run);
  FTokenID := tkSymbol;
//  inc(FRoundCount);                                                           //mh 2000-01-21
end;

procedure TwmSybSQLSyn.SemiColonProc;
begin
  inc(Run);                            {semicolon}
  fTokenID := tkSymbol;
end;

procedure TwmSybSQLSyn.SlashProc;
begin
  case FLine[Run + 1] of
    '*':
      begin
        fRange := rsComment;
        inc(Run);
        fTokenID := tkComment;       {c style comment}

        inc(Run);
        while fLine[Run] <> #0 do
          case fLine[Run] of
            '*':
              if fLine[Run + 1] = '/' then
              begin
                fRange := rsUnKnown;
                inc(Run, 2);
                break;
              end else inc(Run);
            #10: break;
            #13: break;
          else inc(Run);
          end;
      end;
    '=':                               {division assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {division}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.SpaceProc;
begin
  inc(Run);
  fTokenID := tkSpace;
  while FLine[Run] in [#1..#9, #11, #12, #14..#32] do inc(Run);
end;

procedure TwmSybSQLSyn.SquareCloseProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
//  dec(FSquareCount);
end;

procedure TwmSybSQLSyn.SquareOpenProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
//  inc(FSquareCount);
end;

procedure TwmSybSQLSyn.StringProc;
begin
  fTokenID := tkString;
  repeat
    case FLine[Run] of
      #0, #10, #13: break;
      #92:                             {backslash}
        {if we have an escaped quote it doesn't count}
        if FLine[Run + 1] = #34 then inc(Run);
    end;
    inc(Run);
  until FLine[Run] = #34;
  if FLine[Run] <> #0 then inc(Run);
end;

procedure TwmSybSQLSyn.TildeProc;
begin
  inc(Run);                            {bitwise complement}
  fTokenId := tkSymbol;
end;

procedure TwmSybSQLSyn.VariableProc;
begin
  fTokenID := tkVariable;
  inc(Run, fStringLen);
  while Identifiers[fLine[Run]] do inc(Run);
end;

procedure TwmSybSQLSyn.XOrSymbolProc;
begin
  Case FLine[Run + 1] of
    '=':                               {xor assign}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else                                 {xor}
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TwmSybSQLSyn.UnknownProc;
begin
  inc(Run);
  fTokenID := tkUnknown;
end;

procedure TwmSybSQLSyn.AnsiCProc;
begin
  fTokenID := tkComment;
  case FLine[Run] of
    #0:
      begin
        NullProc;
        exit;
      end;
    #10:
      begin
        LFProc;
        exit;
      end;
    #13:
      begin
        CRProc;
        exit;
      end;
  end;

  while FLine[Run] <> #0 do
    case FLine[Run] of
      '*':
        if fLine[Run + 1] = '/' then
        begin
          inc(Run, 2);
          fRange := rsUnKnown;
          break;
        end
        else inc(Run);
      #10: break;
      #13: break;
    else inc(Run);
    end;
end;

procedure TwmSybSQLSyn.Next;
begin
  fTokenPos := Run;
  Case fRange of
    rsComment: AnsiCProc;
    else
      fRange := rsUnknown;
      fProcTable[fLine[Run]];
  end;
end;

{begin}                                                                         //mh 2000-01-17
function TwmSybSQLSyn.GetDefaultAttribute(Index: integer): TmwHighLightAttributes;
begin
  case Index of
    MW_DEFATTR_COMMENT: Result := fCommentAttri;
    MW_DEFATTR_KEYWORD: Result := fKeyAttri;
    MW_DEFATTR_WHITESPACE: Result := fSpaceAttri;
    else Result := nil;
  end;
end;
{end}                                                                           //mh 2000-01-17

function TwmSybSQLSyn.GetEOL: Boolean;
begin
  Result := fTokenID = tkNull;
end;

function TwmSybSQLSyn.GetRange: Pointer;
begin
  Result := Pointer(fRange);
end;

function TwmSybSQLSyn.GetToken: String;
var
  Len: LongInt;
begin
  Len := Run - fTokenPos;
  SetString(Result, (FLine + fTokenPos), Len);
end;

function TwmSybSQLSyn.GetTokenID: TtkTokenKind;
begin
  Result := fTokenId;
end;

function TwmSybSQLSyn.GetTokenAttribute: TmwHighLightAttributes;
begin
  case GetTokenID of
    tkComment: Result := fCommentAttri;
    tkIdentifier: Result := fIdentifierAttri;
    tkInvalidSymbol: Result := fInvalidSymbolAttri;
    tkKey: Result := fKeyAttri;
    tkNumber: Result := fNumberAttri;
    tkSpace: Result := fSpaceAttri;
    tkString: Result := fStringAttri;
    tkSymbol: Result := fSymbolAttri;
    tkVariable: Result := fVariableAttri;
    tkUnknown: Result := fIdentifierAttri;
    else Result := nil;
  end;
end;

function TwmSybSQLSyn.GetTokenKind: integer;
begin
  Result := Ord(fTokenId);
end;

function TwmSybSQLSyn.GetTokenPos: Integer;
begin
  Result := fTokenPos;
end;

procedure TwmSybSQLSyn.ReSetRange;
begin
  fRange := rsUnknown;
end;

procedure TwmSybSQLSyn.SetRange(Value: Pointer);
begin
  fRange := TRangeState(Value);
end;

function TwmSybSQLSyn.GetIdentChars: TIdentChars;
begin
  Result := ['_', '0'..'9', 'a'..'z', 'A'..'Z'];
end;

class function TwmSybSQLSyn.GetLanguageName: string;                            //gp 2000-01-20
begin
  Result := MWS_LangSybaseSQL;
end;

class function TwmSybSQLSyn.GetCapability: THighlighterCapability;              //gp 2000-01-20
begin
  Result := inherited GetCapability + [hcExportable];
end;

procedure TwmSybSQLSyn.SetLineForExport(NewValue: String);
begin
  fLine := PChar(NewValue);
  Run := 0;
  ExportNext;
end;

procedure TwmSybSQLSyn.ExportNext;
begin
{begin}                                                                         //mh 2000-01-14
  Next;
  if Assigned(Exporter) then
    with TmwCustomExport(Exporter) do
      case GetTokenID of
        tkComment: FormatToken(GetToken, fCommentAttri, True, False);
        tkIdentifier: FormatToken(GetToken, fIdentifierAttri, False, False);
        tkInvalidSymbol: FormatToken(GetToken, fInvalidSymbolAttri, False, False);
        tkKey: FormatToken(GetToken, fKeyAttri, False, False);
        // Needed to catch line breaks
        tkNull: FormatToken('', nil, False, False);
        tkNumber: FormatToken(GetToken, fNumberAttri, False, False);
        tkSpace: FormatToken(GetToken, fSpaceAttri, False, True);
        tkString: FormatToken(GetToken, fStringAttri, True, False);
        tkSymbol: FormatToken(GetToken, fSymbolAttri, True, False);
        tkVariable: FormatToken(GetToken, fVariableAttri, False, False);
      end;
{end}                                                                           //mh 2000-01-14
end;

initialization
  MakeIdentTable;
  RegisterPlaceableHighlighter(TwmSybSQLSyn);                                   //gp 2000-01-20
end.

